---
title: 'PaymentRequest: shippingoptionchange event'
slug: Web/API/PaymentRequest/shippingoptionchange_event
tags:
  - API
  - Commerce
  - Payment Request
  - Payment Request API
  - PaymentRequest
  - Reference
  - Shipping
  - events
  - onshippingoptionchange
  - payment
  - shippingoptionchange
---
<p>{{securecontext_header}}{{APIRef("Payment Request API")}}</p>

<p><span class="seoSummary">For payment requests that request shipping information, and for which shipping options are offered, the <code><strong>shippingoptionchange</strong></code> event is sent to the {{domxref("PaymentRequest")}} whenever the user chooses a shipping option from the list of available options.</span> The string identifying the currently-selected shipping option can be found in the {{domxref("PaymentRequest.shippingOption", "shippingOption")}} property.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("PaymentRequestUpdateEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("PaymentRequest.onshippingoptionchange", "onshippingoptionchange")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>This code snippet sets up a handler for the <code>shippingoptionchange</code> event. The code recalculates the total charge for the payment based on the selected shipping option. For example, if there are three options (such as "Free ground shipping", "2-day air", and "Next day"), each time the user chooses one of those options, this event handler is called to recalculate the total based on the changed shipping option.</p>

<pre class="brush:js">paymentRequest.addEventListener("shippingoptionchange", event =&gt; {
  const value = calculateNewTotal(paymentRequest.shippingOption);
  const total = {
    currency: "EUR",
    label: "Total due",
    value,
  };
  event.updateWith({ total });
}, false);
</pre>

<p>After caling a custom function, <code>calculateNewTotal()</code>, to compute the updated total based on the newly-selected shipping option as specified by the {{domxref("PaymentRequest.shippingOption", "shippingOption")}}. The revised total is submitted back to the payment request by calling the event's {{domxref("PaymentRequestUpdateEvent.updateWith", "updateWith()")}} method.</p>

<p>You can also create an event handler for <code>shippingoptionchange</code> using its corresponding event handler property, {{domxref("PaymentReques.onshippingoptionchange", "onshippingoptionchange")}}:</p>

<pre class="brush: js">paymentRequest.onshippingoptionchange = event =&gt; {
  const value = calculateNewTotal(paymentRequest.shippingOption);
  const total = {
    currency: "EUR",
    label: "Total due",
    value,
  };
  event.updateWith({ total });
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment','#dfn-shippingoptionchange','shippingoptionchange')}}</td>
   <td>{{Spec2('Payment')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PaymentRequest.shippingoptionchange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("PaymentRequest.onshippingoptionchange", "onshippingoptionchange")}} event handler property</li>
</ul>
</div>
